﻿
--[[
--                                           MOUNTY ©2009 through 2015 or (c)2009 through 2015
--                                                         by William B. Steele
--                                              [ Draewind <> Silver Hand US <> Alliance ]
--                                                         WOWUI@CompuBall.com
--   
--		This program is free software: you can redistribute it and/or modifyit under the terms of the GNU General Public License as published by
--		the Free Software Foundation, either version 3 of the License, or(at your option) any later version.
		
--		This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
--		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

--		You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>
--]]
--[[
--]]
--------------------------------------------------------------------------------------------------------------------------------
--Slash Command Events------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function Mounty_SCommand(msg)
	local oldmsg = msg;
	local num2=0;num3=0;num4=0;
	if (msg) then
		msg=string.lower(msg);
		_,_, msg1, msg2, msg3, msg4 = string.find(msg, "(%S+) (%S+) (%S+) (%S+)");
		if not msg1 then _,_, msg1, msg2, msg3 = string.find(msg, "(%S+) (%S+) (%S+)") end
		if not msg1 then _,_, msg1, msg2 = string.find(msg, "(%S+) (%S+)") end
		if not msg1 then _,_, msg1 = string.find(msg, "(%S+)") end
		if msg1 then msg=msg1 else msg=nil end
		if msg2 then num2 = tonumber(msg2) end --, num2 = math.modf(num2) end
		if msg3 then num3 = tonumber(msg3) end --, num3 = math.modf(num3) end
		if msg2 then num4 = tonumber(msg4) end --, num4 = math.modf(num4) end
	end
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff----- <Mounty> msg = "..msg.."|r");
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff----- <Mounty> msg1 = "..msg1.."|r");
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff----- <Mounty> msg2 = "..msg2.."|r");
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff----- <Mounty> msg3 = "..msg3.."|r");
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff----- <Mounty> msg4 = "..msg4.."|r");
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff----- <Mounty> num2 = "..num2.."|r");
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff----- <Mounty> num3 = "..num3.."|r");
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff----- <Mounty> num3 = "..num4.."|r");
	if (msg) then
--		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff----- <Mounty> Message = "..msg.."|r");
		nsg = tonumber(msg)
		if (msg == "test") then
--			Mounty_Test();
		elseif(msg == "menu") then
			Mounty_Message(false);
		elseif(msg == "info") then
			Mounty_PrintInfo();
		elseif(msg == "set") then
			Mounty_PrintSettings();
		elseif(msg == "reset") then
		   	Mounty_ResetVersion(true);
		   	Mounty_SetAll();
--		   	Mounty_PrintSettings(true);Mounty_ClearMounts()
		elseif(msg == "show") then
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------|r");
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> TOC Version = |r"..MOUNTY_TOC);
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Program> TOC Version = |r"..MOUNTY_WOWTOC);
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Build = |r"..MOUNTY_BUILD);
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Program> Build = |r"..MOUNTY_WOWBUILD);
		   	Mounty_PrintSettings(true);
		elseif(msg == "clear") then
		   	Mounty_ClearMounts();
		   	Mounty_SetAll();
		   	Mounty_PrintSettings(true);
		elseif(msg == "enable") then
		   	Mounty_Enable();
		elseif (msg == "disable") then
		   	Mounty_Disable();
		elseif(msg == "safe") then
			Mounty_SafeFlyToggle();
		elseif(msg == "char") then
			if not Mounty.perChar then
				Mounty_perCharToggle();
			else
--			 	PlaySoundFile(MOUNTY_ErrorSound);
	  			DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty Macro> is already in the Character Specific Tab.|r");
	  		end
		elseif(msg == "gen") then
			if Mounty.perChar then
				Mounty_perCharToggle();
			else
--			 	PlaySoundFile(MOUNTY_ErrorSound);
	  			DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty Macro> is already in the General tab.|r");
	  		end
		elseif (msg == "fly") or (msg == "ride") or (msg == "middle") or (msg == "left") or (msg == "right") then
	   		Mounty_SetMount(Mounty_ConvertSetVal(msg));
		elseif(nsg) then
			if(nsg > 0) and (nsg < 10) then
		   		Mounty_SetMount(nsg);
			else
				Mounty_BadMessage(msg, oldmsg);
		   	end
		else
			Mounty_BadMessage(msg, oldmsg);
		end
	else
		Mounty_Message(true);
	end
end

--------------------------------------------------------------------------------------------------------------------------------
-- Localization
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
-- Global Variables
--------------------------------------------------------------------------------------------------------------------------------
function MOUNTY_INFO()
	local sversion, build, builddate, tocversion = GetBuildInfo();
	local version = tonumber(string.sub(string.gsub(sversion, "%.", ""), 1, 2));
	local z = string.sub(string.gsub(sversion, "%.", ""), 1, 2);
	local y = string.sub(z, 1, 1);
	local x = string.sub(z, 2, -1);
	local ptocversion = "y0x00";
	ptocversion = string.gsub("y0x00", "y", y)
	ptocversion = string.gsub(ptocversion, "x", x)
	return tocversion, ptocversion, sversion, version;
end

MOUNTY_NAME = GetAddOnMetadata("Mounty", "Title");
MOUNTY_VERSION = GetAddOnMetadata("Mounty", "Version");
MOUNTY_TOC, MOUNTY_WOWTOC, MOUNTY_WOWBUILD, MOUNTY_BUILD = MOUNTY_INFO();

--MOUNTY_INTERFACE = GetAddOnMetadata("Mounty", "X-Interface");
MOUNTY_FILENUM = GetAddOnMetadata("Mounty", "X-FileNumber");
MOUNTY_InWorld = false;
MOUNTY_SAFEFLY = " \[noflying\] \[button:2\] ";

MOUNTY_WINTERGRASP = false;
MOUNTY_WINTERGRASPTIMER = true;
MOUNTY_CONTINENT = "Unknown";
MOUNTY_VASHJ_FLAG = false;
MOUNTY_VASHJ_TEXT = "Vashj\'ir"
MOUNTY_SWIMFLAG = false;
MOUNTY_ZONE = "Unknown";

Mounty ={};
Mounty["Name"] = MOUNTY_NAME;
Mounty["FileNumber"] = MOUNTY_FILENUM;
Mounty["Version"] = "0.0.0.0";
Mounty["SelectEnable"] = true;
Mounty["Enabled"] = false;
Mounty["SafeFly"] = true;
Mounty["perChar"] = false;

Mounty["Fly"] = {}
Mounty.Fly["nomod"] = {};
Mounty.Fly.nomod["name"] = "None Set";
Mounty.Fly.nomod["coord"] = 0;
Mounty.Fly["Shift"] = {};
Mounty.Fly.Shift["name"] = "None Set";
Mounty.Fly.Shift["coord"] = 0;

Mounty["Ride"] = {}
Mounty.Ride["nomod"] = {};
Mounty.Ride.nomod["name"] = "None Set";
Mounty.Ride.nomod["coord"] = 0;
Mounty.Ride["Shift"] = {};
Mounty.Ride.Shift["name"] = "None Set";
Mounty.Ride.Shift["coord"] = 0;

Mounty["MiddleButton"] = {}
Mounty.MiddleButton["nomod"] = {};
Mounty.MiddleButton.nomod["name"] = "None Set";
Mounty.MiddleButton.nomod["coord"] = 0;
Mounty.MiddleButton["Shift"] = {};
Mounty.MiddleButton.Shift["name"] = "None Set";
Mounty.MiddleButton.Shift["coord"] = 0;

local i,ii;
local buttonString;
for i=4,9 do
	buttonString = "Button"..i;
	Mounty[buttonString] = {}
	Mounty[buttonString]["nomod"] = {};
	Mounty[buttonString].nomod["name"] = "None Set";
	Mounty[buttonString].nomod["coord"] = 0;
	Mounty[buttonString]["Shift"] = {};
	Mounty[buttonString].Shift["name"] = "None Set";
	Mounty[buttonString].Shift["coord"] = 0;
end
--[[
Mounty["Button4"] = {}
Mounty.Button4["nomod"] = {};
Mounty.Button4.nomod["name"] = "None Set";
Mounty.Button4.nomod["coord"] = 0;
Mounty.Button4["Shift"] = {};
Mounty.Button4.Shift["name"] = "None Set";
Mounty.Button4.Shift["coord"] = 0;

Mounty["Button5"] = {}
Mounty.Button5["nomod"] = {};
Mounty.Button5.nomod["name"] = "None Set";
Mounty.Button5.nomod["coord"] = 0;
Mounty.Button5["Shift"] = {};
Mounty.Button5.Shift["name"] = "None Set";
Mounty.Button5.Shift["coord"] = 0;
--]]

MOUNTY = {
	["Alliance"] = {
		["ride"] = "None Set";
		["shiftride"] = "None Set";
		["fly"] = "None Set";
		["shiftfly"] = "None Set";
	};
	["Horde"] = {
		["ride"] = "None Set";
		["shiftride"] = "None Set";
		["fly"] = "None Set";
		["shiftfly"] = "None Set";
	};
	["MAP"] = {};
	["AddMap"] = {};
};

GARRISON_Buildings = {};
ContinentZone_Test = {};

function MOUNTY_TEST()
	ContinentZone_Test = nil;
	ContinentZone_Test = {};
	ContinentZone_Test["Proper_GetMapContinents"] = {"Kalimdor", "Eastern Kingdoms", "Outland", "Northrend", "The Maelstrom", "Pandaria", "Draenor"};
	ContinentZone_Test["Proper_GetMapZones"] = {"Ashran", "Frostfire Ridge", "Gorgrond", "Nagrand", "Shadowmoon Valley", "Spires of Arak", "Talador", "Tanaan Jungle"};
	ContinentZone_Test["Current_GetMapContinents"] = {GetMapContinents()};
	ContinentZone_Test["Current_GetMapZones"] = {GetMapZones(7)};
end

local ALIVE = true;


--------------------------------------------------------------------------------------------------------------------------------
-- OnLoad
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_OnLoad(frame)
-- Create LUA Frames
	CreateFrame("GameTooltip","MountyToolTip",UIParent,"GameTooltipTemplate") -- Build pseudo-tooltip to use for scanning.

-- Register Events	
	frame:RegisterEvent("ADDON_LOADED");
	frame:RegisterEvent("PLAYER_ENTERING_WORLD");
	frame:RegisterEvent("LEARNED_SPELL_IN_TAB");
	frame:RegisterEvent("COMPANION_LEARNED");
	frame:RegisterEvent("PLAYER_REGEN_ENABLED");
	frame:RegisterEvent("UNIT_AURA");
--	frame:RegisterEvent("ZONE_CHANGED");
--	frame:RegisterEvent("ZONE_CHANGED_INDOORS");
	frame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	frame:RegisterEvent("UPDATE_WORLD_STATES");
--	frame:RegisterEvent("CORPSE_IN_INSTANCE");
	frame:RegisterEvent("PLAYER_UNGHOST");
	frame:RegisterEvent("PLAYER_ALIVE");
	frame:RegisterEvent("PLAYER_DEAD");
-- Slash Commands
	SlashCmdList["Mounty"] = Mounty_SCommand;
	SLASH_Mounty1 = "/mty";
	SLASH_Mounty2 = "/MTY";
	SLASH_Mounty3 = "/mounty";
	SLASH_Mounty4 = "/Mounty";
	SLASH_Mounty5 = "/MOUNTY";
end

--------------------------------------------------------------------------------------------------------------------------------
-- OnEvent
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_OnEvent(frame, event, ...)
	if (event == "ADDON_LOADED") then
		if(arg1 == "Mounty") then
--			Mounty_InitializeVar();
		end
	elseif (event == "PLAYER_ENTERING_WORLD") then
		if not MOUNTY_InWorld then
			MOUNTY_InWorld = true;
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r  File: "..MOUNTY_FILENUM.."|cff00ffff by Drae|r");
		end
		Mounty_SetAll();
	end
	if (event == "PLAYER_DEAD") then
		ALIVE = false;
	end
	if Mounty.Enabled and ALIVE then
		if (event == "LEARNED_SPELL_IN_TAB") then
			Mounty_SetAll();
		elseif (event == "COMPANION_LEARNED") then
			Mounty_SetAll();
		elseif (event == "ZONE_CHANGED_NEW_AREA") then
			local old = MOUNTY_CONTINENT;
--			local name,instance = GetInstanceInfo();
			Mounty_ContinentChange(old);
		elseif (event == "UPDATE_WORLD_STATES") then
			local wintergrasp = MOUNTY_WINTERGRASPTIMER;
			MOUNTY_WINTERGRASPTIMER = Mounty_Wintergrasp();
			if not (wintergrasp == MOUNTY_WINTERGRASPTIMER) then
--				if MOUNTY_WINTERGRASP then
					Mounty_SetAll();
--				end
			end
		elseif (event == "PLAYER_REGEN_ENABLED") then
			if MOUNTY_InWorld then
				Mounty_ExitCombat();
			end
		end
	end
	if (event == "PLAYER_ALIVE") or (event == "PLAYER_UNGHOST") then
		ALIVE = true;
		Mounty_ExitCombat();
	end
end

function Mounty_ContinentChange(old)
	MOUNTY_CONTINENT = Mounty_GetContinentName();
	if not (old == MOUNTY_CONTINENT) or Mounty_VashjCheck() then
		Mounty_SetAll();
	end
	old = MOUNTY_WINTERGRASP;
	if ("Wintergrasp" == GetRealZoneText()) then
		MOUNTY_WINTERGRASP = true;
		Mounty_Wintergrasp();
		if not wintergrasp then
			Mounty_SetAll();
		end
	else
		MOUNTY_WINTERGRASP = false;
		if old then
			Mounty_SetAll();
		end
	end
end

-- TEST EVENTS --
